﻿var arena = {
	width: 512,
	height: 256
};
var ship = {
	posX: 128,
	posY: 128,
	dir: "up",
	hasHitObstacle: false,		// what is this even for?
	isIntact: true
};
// classes are overrated
var barrier1 = {
	width: 32,
	height: 96,
	posX: 352,
	posY: 112
};
var barrier2 = {
	width: 112,
	height: 16,
	posX: 144,
	posY: 48
};
var barrier3 = {
	width: 64,
	height: 64,
	posX: 48,
	posY: 192
};
var globalSpeed = 100;
var moveAmount = 2;
var gameIsRunning = false;

function init() {
	gameIsRunning = false;
	
	ship.isIntact = true;
	
	document.getElementById("arena").style.width = arena.width + "px";
	document.getElementById("arena").style.height = arena.height + "px";
	document.getElementById("ship").style.left = ship.posX + "px";
	document.getElementById("ship").style.top = ship.posY + "px";
	
	document.getElementById("barrier1").style.width = barrier1.width + "px";
	document.getElementById("barrier1").style.height = barrier1.height + "px";
	document.getElementById("barrier1").style.left = barrier1.posX + "px";
	document.getElementById("barrier1").style.top = barrier1.posY + "px";
	
	document.getElementById("barrier2").style.width = barrier2.width + "px";
	document.getElementById("barrier2").style.height = barrier2.height + "px";
	document.getElementById("barrier2").style.left = barrier2.posX + "px";
	document.getElementById("barrier2").style.top = barrier2.posY + "px";
	
	document.getElementById("barrier3").style.width = barrier3.width + "px";
	document.getElementById("barrier3").style.height = barrier3.height + "px";
	document.getElementById("barrier3").style.left = barrier3.posX + "px";
	document.getElementById("barrier3").style.top = barrier3.posY + "px";
	// event listener, or something
	document.onkeydown = function(event) {
		if (!gameIsRunning) {
			// enter key
			if (event.keyCode === 13) {
				event.preventDefault();
				gameIsRunning = true;
				moveShip();
			}
		}
		if (ship.isIntact) {
			// left arrow key
			if (event.keyCode === 37) {
				event.preventDefault();
				changeDir("left");
			}
			// up arrow key
			if (event.keyCode === 38) {
				event.preventDefault();
				changeDir("up");
			}
			// right arrow key
			if (event.keyCode === 39) {
				event.preventDefault();
				changeDir("right");
			}
			// down arrow key
			if (event.keyCode === 40) {
				event.preventDefault();
				changeDir("down");
			}
		}
	}
}
function moveShip() {
	checkCollision();
	if (ship.isIntact) {
		switch (ship.dir) {
			case "up":
				ship.posY -= moveAmount;
				break;
			case "down":
				ship.posY += moveAmount;
				break;
			case "left":
				ship.posX -= moveAmount;
				break;
			case "right":
				ship.posX += moveAmount;
				break;
		}
	document.getElementById("ship").style.top = ship.posY + "px";
	document.getElementById("ship").style.left = ship.posX + "px";
	window.setTimeout(function(){ moveShip(); }, globalSpeed);
	}
	else {
		destroyShip();
	}
}
function changeDir(direction_) {
	ship.dir = direction_;
	switch (direction_) {
		// I like CSS sprites, mkay?
		case "up":
			changeSprite(0, 0);
			break;
		case "right":
			changeSprite(1, 0);
			break;
		case "down":
			changeSprite(2, 0);
			break;
		case "left":
			changeSprite(3, 0);
			break;
	}
}
function changeSprite(x_, y_) {
	document.getElementById("ship").style.backgroundPosition = -(16 * x_) + "px " + -(16 * y_) + "px";	// sprite is 16 * 16 px in size
}
function checkCollision() {
	// this looks gorgeous
	if ((ship.posX <= 0) ||						// arena left
		(ship.posY <= 0) ||						// arena top
		(ship.posX >= arena.width - 16) ||		// arena right
		(ship.posY >= arena.height - 16) || 	// arena bottom
		// why is this even a seperate function?
		(checkBarrierCollision())) {			// checking whether ship is inside/touching barrier
			ship.isIntact = false;
	}
}
function checkBarrierCollision() {
	// this is getting ridiculous
	if (checkIndividualBarrierCollision(barrier1) || checkIndividualBarrierCollision(barrier2) || checkIndividualBarrierCollision(barrier3)) {
		return true;
	}
	else {
		return false;
	}
}
function checkIndividualBarrierCollision(barrier) {
	// Dios mío
	if (((ship.posX >= barrier.posX - 16) && (ship.posX <= barrier.posX + barrier.width)) &&		// ship is horizontally between barrier boundaries
		((ship.posY >= barrier.posY - 16) && (ship.posY <= barrier.posY + barrier.height))) {		// ship is vertically between barrier boundaries
			return true;
	}
	else {
		return false;
	}
}
function destroyShip() {
	// Well, thanks a lot, JavaScript
	destroyShipPart1();
}
function destroyShipPart1() {
	changeSprite(0, 1);
	window.setTimeout(function() { destroyShipPart2(); }, 100);
}
function destroyShipPart2() {
	changeSprite(1, 1);
	window.setTimeout(function() { destroyShipPart3(); }, 100);
}
function destroyShipPart3() {
	changeSprite(2, 1);
	window.setTimeout(function() { destroyShipPart4(); }, 100);
}
function destroyShipPart4() {
	changeSprite(3, 1);
	window.setTimeout(function() { destroyShipPart5(); }, 100);
}
function destroyShipPart5() {
	changeSprite(0, 2);
}